/// <reference types="node" />
import { MugshotSelector } from '../lib/mugshot';
export interface ScreenshotOptions {
    /**
     * All elements identified by this selector will be painted black
     * before taking the screenshot.
     * TODO: support multiple selectors
     * TODO: configure the color
     */
    ignore?: MugshotSelector;
}
/**
 * Thrown when the selector passed to [[Mugshot.check]] matches more than one
 * element.
 */
export declare class TooManyElementsError extends Error {
    constructor(selector: MugshotSelector);
}
export default interface Screenshotter {
    /**
     * Take a viewport screenshot.
     */
    takeScreenshot(options?: ScreenshotOptions): Promise<Buffer>;
    /**
     * Take a screenshot of a single element.
     *
     * Will throw [[TooManyElementsError]] if `selector` matches more than one element.
     */
    takeScreenshot(selector: MugshotSelector, options?: ScreenshotOptions): Promise<Buffer>;
}
