/// <reference types="node" />
import ScreenshotStorage from '../interfaces/screenshot-storage';
/**
 * Write and read baselines to and from the local file system.
 *
 * Screenshots will be saved with a `.png` extension.
 */
export default class FsStorage implements ScreenshotStorage {
    private readonly resultsPath;
    /**
     * @param resultsPath The entire folder structure will be created if missing.
     */
    constructor(resultsPath: string);
    write: (name: string, data: Buffer) => Promise<void>;
    exists: (name: string) => Promise<boolean>;
    read: (name: string) => Promise<Buffer>;
    delete: (name: string) => Promise<void>;
    private getPath;
}
