"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MugshotMissingBaselineError = void 0;
/* eslint-disable max-classes-per-file */
var is_ci_1 = __importDefault(require("is-ci"));
var pixel_differ_1 = __importDefault(require("./pixel-differ"));
var MugshotMissingBaselineError = /** @class */ (function (_super) {
    __extends(MugshotMissingBaselineError, _super);
    function MugshotMissingBaselineError(name) {
        return _super.call(this, "Missing baseline for " + name) || this;
    }
    return MugshotMissingBaselineError;
}(Error));
exports.MugshotMissingBaselineError = MugshotMissingBaselineError;
var Mugshot = /** @class */ (function () {
    /**
     * @param screenshotter
     * @param storage How to read and store screenshots.
     * @param createMissingBaselines Defaults to false in a CI env, true otherwise.
     * @param __namedParameters [[MugshotOptions]]
     */
    function Mugshot(screenshotter, storage, _a) {
        var _this = this;
        var _b = _a === void 0 ? {} : _a, _c = _b.pngDiffer, pngDiffer = _c === void 0 ? new pixel_differ_1.default() : _c, _d = _b.createMissingBaselines, createMissingBaselines = _d === void 0 ? !is_ci_1.default : _d, _e = _b.updateBaselines, updateBaselines = _e === void 0 ? false : _e;
        this.screenshotter = screenshotter;
        this.storage = storage;
        this.cleanup = function (name) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.storage.delete(name + ".diff")];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.storage.delete(name + ".actual")];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.pngDiffer = pngDiffer;
        this.createMissingBaselines = createMissingBaselines;
        this.updateBaselines = updateBaselines;
    }
    // eslint-disable-next-line no-dupe-class-members
    Mugshot.prototype.check = function (name, selectorOrOptions, options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var selector, baselineExists, actual, expected, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof selectorOrOptions === 'string' ||
                            (typeof selectorOrOptions !== 'undefined' && 'x' in selectorOrOptions)) {
                            selector = selectorOrOptions;
                        }
                        else if (typeof selectorOrOptions === 'object') {
                            // eslint-disable-next-line no-param-reassign
                            options = selectorOrOptions;
                        }
                        return [4 /*yield*/, this.storage.exists(name)];
                    case 1:
                        baselineExists = _a.sent();
                        if (!baselineExists) {
                            if (this.createMissingBaselines || this.updateBaselines) {
                                return [2 /*return*/, this.writeBaseline(name, options, selector)];
                            }
                            throw new MugshotMissingBaselineError(name);
                        }
                        else if (this.updateBaselines) {
                            return [2 /*return*/, this.writeBaseline(name, options, selector)];
                        }
                        return [4 /*yield*/, this.getScreenshot(selector, options)];
                    case 2:
                        actual = _a.sent();
                        return [4 /*yield*/, this.storage.read(name)];
                    case 3:
                        expected = _a.sent();
                        return [4 /*yield*/, this.pngDiffer.compare(expected, actual)];
                    case 4:
                        result = _a.sent();
                        if (!result.matches) {
                            return [2 /*return*/, this.diff(name, expected, result.diff, actual)];
                        }
                        return [4 /*yield*/, this.cleanup(name)];
                    case 5:
                        _a.sent();
                        return [2 /*return*/, {
                                matches: true,
                                expected: expected,
                                expectedName: name,
                            }];
                }
            });
        });
    };
    Mugshot.prototype.writeBaseline = function (name, options, selector) {
        return __awaiter(this, void 0, void 0, function () {
            var expected;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getScreenshot(selector, options)];
                    case 1:
                        expected = _a.sent();
                        return [4 /*yield*/, this.storage.write(name, expected)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.cleanup(name)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, {
                                matches: true,
                                expected: expected,
                                expectedName: name,
                            }];
                }
            });
        });
    };
    Mugshot.prototype.diff = function (name, expected, diff, actual) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.storage.write(name + ".diff", diff)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.storage.write(name + ".actual", actual)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, {
                                matches: false,
                                expected: expected,
                                actual: actual,
                                diff: diff,
                                expectedName: name,
                                diffName: name + ".diff",
                                actualName: name + ".actual",
                            }];
                }
            });
        });
    };
    Mugshot.prototype.getScreenshot = function (selector, options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, selector
                        ? this.screenshotter.takeScreenshot(selector, options)
                        : this.screenshotter.takeScreenshot(options)];
            });
        });
    };
    return Mugshot;
}());
exports.default = Mugshot;
//# sourceMappingURL=mugshot.js.map