"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jimp_1 = __importDefault(require("jimp"));
var pixelmatch_1 = __importDefault(require("pixelmatch"));
/**
 * Compare screenshots pixel by pixel using
 * [pixelmatch](https://github.com/mapbox/pixelmatch).
 *
 * Images with different dimensions will always fail comparison and a diff
 * indicating the extra region will be returned.
 */
var PixelDiffer = /** @class */ (function () {
    /**
     * @param __namedParameters [[PixelDifferOptions]]
     */
    function PixelDiffer(_a) {
        var _this = this;
        var _b = _a === void 0 ? {} : _a, _c = _b.diffColor, diffColor = _c === void 0 ? { r: 255, g: 0, b: 0 } : _c, _d = _b.threshold, threshold = _d === void 0 ? 0 : _d;
        this.compare = function (expected, actual) { return __awaiter(_this, void 0, void 0, function () {
            var expectedJimp, actualJimp, smallestWidth, smallestHeight, biggestWidth, biggestHeight, differentSize, diffJimp, numDiffPixels, matches, wholeDiffJimp;
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, jimp_1.default.read(expected)];
                    case 1:
                        expectedJimp = _c.sent();
                        return [4 /*yield*/, jimp_1.default.read(actual)];
                    case 2:
                        actualJimp = _c.sent();
                        smallestWidth = Math.min(expectedJimp.getWidth(), actualJimp.getWidth());
                        smallestHeight = Math.min(expectedJimp.getHeight(), actualJimp.getHeight());
                        biggestWidth = Math.max(expectedJimp.getWidth(), actualJimp.getWidth());
                        biggestHeight = Math.max(expectedJimp.getHeight(), actualJimp.getHeight());
                        differentSize = expectedJimp.getWidth() !== actualJimp.getWidth() ||
                            expectedJimp.getHeight() !== actualJimp.getHeight();
                        if (differentSize) {
                            expectedJimp.crop(0, 0, smallestWidth, smallestHeight);
                            actualJimp.crop(0, 0, smallestWidth, smallestHeight);
                        }
                        diffJimp = new jimp_1.default(smallestWidth, smallestHeight, 0xffffffff);
                        numDiffPixels = pixelmatch_1.default(expectedJimp.bitmap.data, actualJimp.bitmap.data, diffJimp.bitmap.data, // this will be modified in place
                        smallestWidth, smallestHeight, {
                            diffColor: [this.diffColor.r, this.diffColor.g, this.diffColor.b],
                            threshold: this.threshold,
                            alpha: 0,
                        });
                        matches = numDiffPixels === 0;
                        if (!differentSize) return [3 /*break*/, 5];
                        wholeDiffJimp = new jimp_1.default(biggestWidth, biggestHeight, '#ff0000');
                        return [4 /*yield*/, wholeDiffJimp.composite(diffJimp, 0, 0)];
                    case 3:
                        _c.sent();
                        _a = {
                            matches: false
                        };
                        return [4 /*yield*/, wholeDiffJimp.getBufferAsync(jimp_1.default.MIME_PNG)];
                    case 4: return [2 /*return*/, (_a.diff = _c.sent(),
                            _a)];
                    case 5:
                        if (matches) {
                            return [2 /*return*/, { matches: true }];
                        }
                        _b = {
                            matches: false
                        };
                        return [4 /*yield*/, diffJimp.getBufferAsync(jimp_1.default.MIME_PNG)];
                    case 6: return [2 /*return*/, (_b.diff = _c.sent(),
                            _b)];
                }
            });
        }); };
        this.diffColor = diffColor;
        this.threshold = threshold;
    }
    return PixelDiffer;
}());
exports.default = PixelDiffer;
//# sourceMappingURL=pixel-differ.js.map