"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var webdriver_1 = require("../interfaces/webdriver");
var screenshotter_1 = require("../interfaces/screenshotter");
var jimp_processor_1 = __importDefault(require("./jimp-processor"));
/* istanbul ignore next because this will be stringified and executed in the client */
function injectAnimationDisablingStylesheet() {
    var style = document.createElement('style');
    style.textContent = "\ninput {\n  caret-color: transparent;\n}\n\n*, *::before, *::after {\n  transition: none !important;\n  animation: none !important;\n}\n";
    document.head.appendChild(style);
}
/**
 * Take screenshots from a Webdriver compatible client.
 */
var WebdriverScreenshotter = /** @class */ (function () {
    /**
     * @param client
     * @param __namedParameters [[WebdriverScreenshotterOptions]]
     */
    function WebdriverScreenshotter(client, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.pngProcessor, pngProcessor = _c === void 0 ? new jimp_processor_1.default() : _c, _d = _b.disableAnimations, disableAnimations = _d === void 0 ? false : _d;
        this.client = client;
        this.pngProcessor = pngProcessor;
        this.disableAnimations = disableAnimations;
    }
    /**
     * Take screenshots of selectors by first taking a viewport screenshot and
     * then cropping the element out.
     *
     * The element's bounding rectangle will be used to crop it out of the
     * viewport screenshot.
     */
    WebdriverScreenshotter.prototype.takeScreenshot = function (selectorOrOptions, options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var selector, screenshot, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (typeof selectorOrOptions === 'string' ||
                            (typeof selectorOrOptions !== 'undefined' && 'x' in selectorOrOptions)) {
                            selector = selectorOrOptions;
                        }
                        else if (typeof selectorOrOptions === 'object') {
                            // eslint-disable-next-line no-param-reassign
                            options = selectorOrOptions;
                        }
                        if (!this.disableAnimations) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.client.execute(injectAnimationDisablingStylesheet)];
                    case 1:
                        _c.sent();
                        _c.label = 2;
                    case 2:
                        _b = (_a = Buffer).from;
                        return [4 /*yield*/, this.client.takeScreenshot()];
                    case 3:
                        screenshot = _b.apply(_a, [_c.sent(), 'base64']);
                        if (!selector) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.crop(selector, screenshot)];
                    case 4:
                        screenshot = _c.sent();
                        _c.label = 5;
                    case 5:
                        if (!options.ignore) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.ignore(options.ignore, screenshot)];
                    case 6:
                        screenshot = _c.sent();
                        _c.label = 7;
                    case 7: return [2 /*return*/, screenshot];
                }
            });
        });
    };
    WebdriverScreenshotter.prototype.crop = function (selector, screenshot) {
        return __awaiter(this, void 0, void 0, function () {
            var rect;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(typeof selector !== 'string')) return [3 /*break*/, 1];
                        rect = selector;
                        return [3 /*break*/, 3];
                    case 1: return [4 /*yield*/, this.client.getElementRect(selector)];
                    case 2:
                        rect = _a.sent();
                        if (!rect) {
                            throw new webdriver_1.ElementNotFoundError(selector);
                        }
                        if (Array.isArray(rect)) {
                            throw new screenshotter_1.TooManyElementsError(selector);
                        }
                        if (rect.width === 0 || rect.height === 0) {
                            throw new webdriver_1.ElementNotVisibleError(selector);
                        }
                        _a.label = 3;
                    case 3: return [2 /*return*/, this.pngProcessor.crop(screenshot, rect.x, rect.y, rect.width, rect.height)];
                }
            });
        });
    };
    WebdriverScreenshotter.prototype.ignore = function (selector, screenshot) {
        return __awaiter(this, void 0, void 0, function () {
            var rects, result, rects_1, rects_1_1, rect, e_1_1;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(typeof selector === 'string')) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.client.getElementRect(selector)];
                    case 1:
                        rects = _b.sent();
                        if (!rects) {
                            throw new webdriver_1.ElementNotFoundError(selector);
                        }
                        if (Array.isArray(rects)) {
                            rects.forEach(function (rect) {
                                if (rect.width === 0 || rect.height === 0) {
                                    throw new webdriver_1.ElementNotVisibleError(selector);
                                }
                            });
                        }
                        else if (rects.width === 0 || rects.height === 0) {
                            throw new webdriver_1.ElementNotVisibleError(selector);
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        rects = selector;
                        _b.label = 3;
                    case 3:
                        if (!Array.isArray(rects)) return [3 /*break*/, 12];
                        result = screenshot;
                        _b.label = 4;
                    case 4:
                        _b.trys.push([4, 9, 10, 11]);
                        rects_1 = __values(rects), rects_1_1 = rects_1.next();
                        _b.label = 5;
                    case 5:
                        if (!!rects_1_1.done) return [3 /*break*/, 8];
                        rect = rects_1_1.value;
                        return [4 /*yield*/, this.pngProcessor.paint(result, rect.x, rect.y, rect.width, rect.height, '#000')];
                    case 6:
                        // eslint-disable-next-line no-await-in-loop
                        result = _b.sent();
                        _b.label = 7;
                    case 7:
                        rects_1_1 = rects_1.next();
                        return [3 /*break*/, 5];
                    case 8: return [3 /*break*/, 11];
                    case 9:
                        e_1_1 = _b.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 11];
                    case 10:
                        try {
                            if (rects_1_1 && !rects_1_1.done && (_a = rects_1.return)) _a.call(rects_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 11: return [2 /*return*/, result];
                    case 12: return [2 /*return*/, this.pngProcessor.paint(screenshot, rects.x, rects.y, rects.width, rects.height, '#000')];
                }
            });
        });
    };
    return WebdriverScreenshotter;
}());
exports.default = WebdriverScreenshotter;
//# sourceMappingURL=webdriver-screenshotter.js.map